import java.util.LinkedList;

public class BFIterator<T> {
 private LinkedList<Node<T>> toVisit;
 public BFIterator(Node<T> n) {
      this.toVisit = new LinkedList<Node<T>>();
      if (n!=null) {this.toVisit.addFirst(n);}
 }
 public boolean hasNext() {
      return !this.toVisit.isEmpty();
 }
 public T next() {
      Node<T> n = this.toVisit.removeFirst();
      Node<T> left= n.getLeft();
      Node<T> right=n.getRight();
      if (left!=null) {this.toVisit.addLast(left);}
      if (right!=null) {this.toVisit.addLast(right);}
      return n.getValue();      
 }
}
