
public class BinTreeTest {

	public static void main(String[] args) {
		BinTree<Integer> k = new BinTree<Integer>(8);
		BinTree<Integer> j = new BinTree<Integer>(7);
		BinTree<Integer> e = new BinTree<Integer>(6);
		BinTree<Integer> f = new BinTree<Integer>(j,5,k);
		BinTree<Integer> g = new BinTree<Integer>(4);
		BinTree<Integer> b = new BinTree<Integer>(e,2,f);
		BinTree<Integer> empty = new BinTree<Integer>();
		BinTree<Integer> c = new BinTree<Integer>(empty,3,g);
		BinTree<Integer> a = new BinTree<Integer>(b,1,c);
		System.out.println(a.sizeElegant());
		System.out.println(a.size());
        DFIterator<Integer> dfi = a.dfIterator();
        while (dfi.hasNext()) {
            System.out.print(dfi.next() + ",");
        }
        System.out.println();
        BFIterator<Integer> bfi = a.bfIterator();
        while (bfi.hasNext()) {
            System.out.print(bfi.next() + ",");
        }
        System.out.println();
		BinTree<String> sk = new BinTree<String>("Markierung 8");
		BinTree<String> sj = new BinTree<String>("Markierung 7");
		BinTree<String> se = new BinTree<String>("Markierung 6");
		BinTree<String> sf = new BinTree<String>(sj,"Markierung 5",sk);
		BinTree<String> sg = new BinTree<String>("Markierung 4");
		BinTree<String> sb = new BinTree<String>(se,"Markierung 2",sf);
		BinTree<String> sempty = new BinTree<String>();
		BinTree<String> sc = new BinTree<String>(sempty,"Markierung 3",sg);
		BinTree<String> sa = new BinTree<String>(sb,"Markierung 1",sc);
        System.out.println("Depth (elegant):" + sa.depthElegant());
        System.out.println("Depth:" + sa.depth());
    		System.out.println(sa.size());
        DFIterator<String> sdfi = sa.dfIterator();
         while (sdfi.hasNext()) {
            System.out.print(sdfi.next() + ",");
        }
        System.out.println();
        BFIterator<String> sbfi = sa.bfIterator();
        while (sbfi.hasNext()) {
            System.out.print(sbfi.next() + ",");
        }
        System.out.println();

	}

}

