import java.util.LinkedList;

public class DFIterator<T> {
 private LinkedList<Node<T>> toVisit;
 public DFIterator(Node<T> n) {
  /* Linked list erstellen und Knoten n einfuegen */
   this.toVisit = new LinkedList<Node<T>>();
      if (n!=null) {this.toVisit.addFirst(n);}
 }
 public boolean hasNext() {
  /* ist Liste nicht-leer ? */
      return !this.toVisit.isEmpty();
 }
 public T next() {
  /* der aktuelle Knoten ist der erste i der Liste */
      Node<T> n = this.toVisit.removeFirst();
  /* fuege Kinder in die Liste ein */
  /* Reihenfolge: left,right,alteListe */
      Node<T> left= n.getLeft();
      Node<T> right=n.getRight();
      if (right!=null) {this.toVisit.addFirst(right);}
      if (left!=null) {this.toVisit.addFirst(left);}
      return n.getValue();      
 }
}
